'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleApiError = handleApiError;

var _fetchNormalizeData = require('fetch-normalize-data');

var _effects = require('redux-saga/effects');

var _error_codes = require('../error_codes');

var _marked = /*#__PURE__*/regeneratorRuntime.mark(handleApiError);

function handleApiError(payload, config) {
  var handleFail, state, action;
  return regeneratorRuntime.wrap(function handleApiError$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          handleFail = config.handleFail;

          payload['error_type'] = _error_codes.API_ERROR;
          _context.next = 4;
          return (0, _effects.put)((0, _fetchNormalizeData.failData)(payload, config));

        case 4:
          if (!handleFail) {
            _context.next = 11;
            break;
          }

          _context.next = 7;
          return (0, _effects.select)(function (s) {
            return s;
          });

        case 7:
          state = _context.sent;
          action = { config: config, payload: payload };
          _context.next = 11;
          return (0, _effects.call)(handleFail, state, action);

        case 11:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked, this);
}

exports.default = handleApiError;